"use strict";

function _interopDefault(ex) {
  return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
}

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var react = require("react"), core = require("@emotion/core"), _defineProperty = _interopDefault(require("@babel/runtime/helpers/defineProperty")), a11y = require("@elemental-ui-alpha/a11y"), theme = require("@elemental-ui-alpha/theme"), _taggedTemplateLiteral = _interopDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

function _templateObject() {
  var data = _taggedTemplateLiteral([ "\n  /*! normalize.css v8.0.1 | MIT License | github.com/necolas/normalize.css */\n  html {\n    line-height: 1.15;\n    -webkit-text-size-adjust: 100%;\n  }\n  body {\n    margin: 0;\n  }\n  main {\n    display: block;\n  }\n  h1 {\n    font-size: 2em;\n    margin: 0.67em 0;\n  }\n  hr {\n    box-sizing: content-box;\n    height: 0;\n    overflow: visible;\n  }\n  pre {\n    font-family: monospace, monospace;\n    font-size: 1em;\n  }\n  a {\n    background-color: transparent;\n  }\n  abbr[title] {\n    border-bottom: none;\n    text-decoration: underline;\n    text-decoration: underline dotted;\n  }\n  b,\n  strong {\n    font-weight: bolder;\n  }\n  code,\n  kbd,\n  samp {\n    font-family: monospace, monospace;\n    font-size: 1em;\n  }\n  small {\n    font-size: 80%;\n  }\n  sub,\n  sup {\n    font-size: 75%;\n    line-height: 0;\n    position: relative;\n    vertical-align: baseline;\n  }\n  sub {\n    bottom: -0.25em;\n  }\n  sup {\n    top: -0.5em;\n  }\n  img {\n    border-style: none;\n  }\n  button,\n  input,\n  optgroup,\n  select,\n  textarea {\n    font-family: inherit;\n    font-size: 100%;\n    line-height: 1.15;\n    margin: 0;\n  }\n  button,\n  input {\n    overflow: visible;\n  }\n  button,\n  select {\n    text-transform: none;\n  }\n  [type='button'],\n  [type='reset'],\n  [type='submit'],\n  button {\n    -webkit-appearance: button;\n  }\n  [type='button']::-moz-focus-inner,\n  [type='reset']::-moz-focus-inner,\n  [type='submit']::-moz-focus-inner,\n  button::-moz-focus-inner {\n    border-style: none;\n    padding: 0;\n  }\n  [type='button']:-moz-focusring,\n  [type='reset']:-moz-focusring,\n  [type='submit']:-moz-focusring,\n  button:-moz-focusring {\n    outline: 1px dotted ButtonText;\n  }\n  fieldset {\n    border: 0;\n    margin: 0;\n    padding: 0;\n  }\n  legend {\n    box-sizing: border-box;\n    color: inherit;\n    display: table;\n    max-width: 100%;\n    padding: 0;\n    white-space: normal;\n  }\n  progress {\n    vertical-align: baseline;\n  }\n  textarea {\n    overflow: auto;\n  }\n  [type='checkbox'],\n  [type='radio'] {\n    box-sizing: border-box;\n    padding: 0;\n  }\n  [type='number']::-webkit-inner-spin-button,\n  [type='number']::-webkit-outer-spin-button {\n    height: auto;\n  }\n  [type='search'] {\n    -webkit-appearance: textfield;\n    outline-offset: -2px;\n  }\n  [type='search']::-webkit-search-decoration {\n    -webkit-appearance: none;\n  }\n  ::-webkit-file-upload-button {\n    -webkit-appearance: button;\n    font: inherit;\n  }\n  details {\n    display: block;\n  }\n  summary {\n    display: list-item;\n  }\n  template {\n    display: none;\n  }\n  [hidden] {\n    display: none;\n  }\n" ]);
  return _templateObject = function() {
    return data;
  }, data;
}

var normalize = core.css(_templateObject());

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach((function(key) {
      _defineProperty(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

var Core = function(_ref) {
  var children = _ref.children, _ref$includeNormalize = _ref.includeNormalize, includeNormalize = void 0 === _ref$includeNormalize || _ref$includeNormalize, _ref$optimizeLegibili = _ref.optimizeLegibility, optimizeLegibility = void 0 === _ref$optimizeLegibili || _ref$optimizeLegibili, theme$1 = _ref.theme;
  return core.jsx(theme.ElementalProvider, {
    theme: theme$1
  }, core.jsx(RootStyles, {
    includeNormalize: includeNormalize,
    optimizeLegibility: optimizeLegibility
  }), core.jsx(App, null, children));
}, App = react.memo((function(props) {
  return core.jsx(react.Fragment, props);
})), RootStyles = function(_ref2) {
  var includeNormalize = _ref2.includeNormalize, optimizeLegibility = _ref2.optimizeLegibility, theme$1 = theme.useElementalTheme();
  return core.jsx(react.Fragment, null, core.jsx(FocusRing, {
    color: theme$1.foreground.focusRing
  }), includeNormalize && core.jsx(core.Global, {
    styles: normalize
  }), core.jsx(core.Global, {
    styles: {
      html: {
        fontSize: "initial !important"
      },
      body: _objectSpread({
        backgroundColor: theme$1.background.base,
        color: theme$1.foreground.text,
        fontSize: "1rem",
        fontWeight: 400,
        lineHeight: 1.428571429,
        fontFamily: '-apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, Helvetica, Arial, sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol"'
      }, optimizeLegibility && {
        fontFeatureSettings: '"liga" 1',
        textRendering: "optimizeLegibility",
        WebkitFontSmoothing: "antialiased",
        MozOsxFontSmoothing: "grayscale",
        MozFontFeatureSettings: '"liga" on'
      })
    }
  }));
}, tabbableElements = "a[href]:focus, area:focus, button:enabled:focus, input:not([type='hidden']):enabled:focus, link[href]:focus, object:focus, select:enabled:focus, textarea:enabled:focus, [tabindex]:focus, [draggable]:focus", FocusRing = function(_ref3) {
  var color = _ref3.color, styles = "keyboard" === a11y.useFocusModality() ? {
    outline: "3px solid ".concat(color),
    outlineOffset: 2
  } : {
    outline: 0
  };
  return core.jsx(core.Global, {
    styles: _defineProperty({}, tabbableElements, styles)
  });
}, forwardRef = react.forwardRef;

Object.defineProperty(exports, "ClassNames", {
  enumerable: !0,
  get: function() {
    return core.ClassNames;
  }
}), Object.defineProperty(exports, "Global", {
  enumerable: !0,
  get: function() {
    return core.Global;
  }
}), Object.defineProperty(exports, "css", {
  enumerable: !0,
  get: function() {
    return core.css;
  }
}), Object.defineProperty(exports, "jsx", {
  enumerable: !0,
  get: function() {
    return core.jsx;
  }
}), Object.defineProperty(exports, "keyframes", {
  enumerable: !0,
  get: function() {
    return core.keyframes;
  }
}), exports.Core = Core, exports.forwardRef = forwardRef;
