import { ComponentPropsWithRef, ElementType, ReactElement } from 'react';
export { css, jsx, keyframes, Global, ClassNames } from '@emotion/core';
export { Core } from './Core';
export declare type ResponsiveProp<T> = T | readonly (T | null)[];
interface ForwardRefComponent<BaseProps, DefaultElementType extends ElementType> {
    (props: BaseProps & ComponentPropsWithRef<DefaultElementType> & {
        as?: never;
    }): ReactElement | null;
    <Comp extends ElementType>(props: ComponentPropsWithRef<Comp> & {
        as: Comp;
    } & BaseProps): ReactElement | null;
}
export declare const forwardRef: <BaseProps, DefaultElementType extends ElementType>(comp: (props: BaseProps & {
    as: ElementType;
    [key: string]: any;
}, ref: React.Ref<any>) => ReactElement) => ForwardRefComponent<BaseProps, DefaultElementType>;
